%{!?kver: %global kver %(uname -r)}
%define kdir /lib/modules/%{kver}/source

Name:           ifs-kernel-updates
Group:		System Environment/Kernel
Summary:        Extra kernel modules for IFS
Version:        %(echo %{kver}|sed -e 's/-/_/g')
Release:        1618cuda
License:        GPLv2
Source0:        %{name}-4.4.114_94.14_default.tgz
Source1:        %{name}.files
Source2:        %{name}.conf
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  %kernel_module_package_buildreqs

Requires:       kernel = %(echo %{kver} | sed -e 's/\(.*\).default/\1/g')

%kernel_module_package -f %{SOURCE1} default

%global kernel_source %(
        echo "/lib/modules/%{kver}/build"
)

%global kernelrpm_ver %(
	echo "%(rpm -q --qf %{VERSION} %(rpm -qf /lib/modules/%{kver}/kernel/))"
)

# find our target version
%global kbuild %(
if [ -z "$kbuild" ]; then
	echo "/lib/modules/%{kver}/build"
else
	echo "$kbuild"
fi
)

%global kver %(
if [ -f "%{kbuild}/include/config/kernel.release" ]; then
	cat %{kbuild}/include/config/kernel.release
else
	echo "fail"
fi
)

%define modlist  rdmavt hfi1 ib_qib
%define kmod_moddir %kernel_module_package_moddir

%description
Updated kernel modules for OPA IFS

%package devel
Summary: Development headers for Intel HFI1 driver interface
Group: System Environment/Development

%description devel
Development header files for Intel HFI1 driver interface

%prep
%setup -qn %{name}-4.4.114_94.14_default
rm -rf %{SOURCE2}
for flavor in %flavors_to_build; do
        for mod in %modlist; do
                rm -rf "$mod"_$flavor
                cp -r $mod  "$mod"_$flavor
		echo "override $mod %{kernelrpm_ver}-* weak-updates/$mod" >> %{SOURCE2}
        done
done

%build
if [ "%kver" = "fail" ]; then
        if [ -z "%kbuild" ]; then
                echo "The default target kernel, %kver, is not installed" >&2
                echo "To build, set \$kbuild to your target kernel build directory" >&2
        else
                echo "Cannot find kernel version in %kbuild" >&2
        fi
        exit 1
fi
echo "Kernel version is %kver"
echo "Kernel source directory is \"%kbuild\""

# Build
#make CONFIG_INFINIBAND_RDMAVT=m
for flavor in %flavors_to_build; do
        for mod in %modlist; do
                rm -rf $mod
                cp -r "$mod"_$flavor $mod
                done
        echo rpm kernel_source %{kernel_source $flavor}
        make CONFIG_INFINIBAND_RDMAVT=m CONFIG_INFINIBAND_HFI1=m CONFIG_INFINIBAND_QIB=m KDIR=%{kernel_source $flavor}
        for mod in %modlist; do
                rm -rf "$mod"_$flavor
                mv -f $mod "$mod"_$flavor
        done
done

%install
install -m 644 -D %{SOURCE2} $RPM_BUILD_ROOT/etc/depmod.d/%{name}.conf
for flavor in %flavors_to_build ; do
        mkdir -p $RPM_BUILD_ROOT/lib/modules/%kver/%kmod_moddir/%{name}
        for mod in %modlist; do
#		make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install M=/nfs/site/home/phcvs2/gitrepo/ifs-all/components/Drivers/tmp/"$mod"_$flavor
		if [[ "1" == "1" ]]; then
			RPM_KMOD_DIR=$RPM_BUILD_ROOT/../../KMODS
			if [ -d $RPM_KMOD_DIR ]; then
				install -m 644 -t $RPM_BUILD_ROOT/lib/modules/%kver/%kmod_moddir/%{name} $RPM_BUILD_ROOT/../../KMODS/"$mod".ko
			else
				echo "WARNING: Installing unsigned kernel module: $mod.ko"
				install -m 644 -t $RPM_BUILD_ROOT/lib/modules/%kver/%kmod_moddir/%{name} "$mod"_$flavor/"$mod".ko
			fi
		else
			install -m 644 -t $RPM_BUILD_ROOT/lib/modules/%kver/%kmod_moddir/%{name} "$mod"_$flavor/"$mod".ko
		fi
        done
done
targetdir=$RPM_BUILD_ROOT%{_includedir}/uapi/rdma/hfi/
rtargetdir=$RPM_BUILD_ROOT%{_includedir}/uapi/rdma/
mkdir -p $targetdir
(srcdir=$(pwd)
cd %kdir
# build 'unifdef' if binary does not exist
if [[ ! -f %kdir/scripts/unifdef ]]; then
	if [[ $(id -u) = 0 ]]; then
		cd scripts
		/usr/bin/gcc unifdef.c -o unifdef
		cd ../
	fi
fi
sh ./scripts/headers_install.sh $targetdir $srcdir include/rdma/hfi/hfi1_user.h
sh ./scripts/headers_install.sh $targetdir $srcdir include/rdma/hfi/hfi1_ioctl.h
sh ./scripts/headers_install.sh $rtargetdir $srcdir include/rdma/rdma_user_ioctl.h
)


%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/uapi/rdma
%dir %{_includedir}/uapi/rdma/hfi
%{_includedir}/uapi/rdma/hfi/hfi1_user.h
%{_includedir}/uapi/rdma/hfi/hfi1_ioctl.h
%{_includedir}/uapi/rdma/rdma_user_ioctl.h
 
%changelog
* Thu Nov 09 2017 Dennis Dalessandro <dennis.dalessandro@intel.com>
- Support latest upstream uAPI header scheme
* Fri Jun 9 2017 Harish Chegondi <harish.chegondi@intel.com>
- Change the path of the hfi1_user.h header so it doesn't conflict with the distro supplied one.
* Sat Sep 24 2016 Alex Estrin <alex.estrin@intel.com>
- Add KMP format spec. Build fix. Minor fix for License string.

